﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Documents.Layout;

namespace RadAutoCompleteBoxSL__1074378
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            this.DataContext = new ViewModel();
        }

        private void RadAutoCompleteBox_SearchTextChanged(object sender, EventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                var autoComplete = sender as RadAutoCompleteBox;
                if (autoComplete != null && autoComplete.IsDropDownOpen)
                {
                    var filteredItems = autoComplete.FilteredItems.Cast<string>();
                    autoComplete.DropDownWidth = MeasureSize(autoComplete.FilteredItems, autoComplete.FontSize, autoComplete.FontFamily);
                }
            }));
        }

        private GridLength MeasureSize(IEnumerable filteredItems, double fontSize, FontFamily fontFamily)
        {
            int maxLength = 0;

            var castList = filteredItems.Cast<string>();
            for (int i = 0; i < castList.Count(); i++)
            {
                if (maxLength < castList.ElementAt(i).Length)
                {
                    maxLength = i;
                }
            }

            var measured = RadTextMeasurer.Measure(castList.ElementAt(maxLength), fontSize, fontFamily);
            return new GridLength(measured.Size.Width);
        }
    }
}
